Android 4.x? (And the Novo 7)

The place to discuss anything and everything about running your LiveCode on Android

Moderators: Klaus, FourthWorld, heatherlaine, robinmiller, kevinmiller

kcorey
Posts: 62
Joined: Fri Nov 25, 2011 6:06 pm

Android 4.x? (And the Novo 7)

Post by kcorey » Thu Jan 05, 2012 10:40 am

Hi All,

I just bought a Novo 7 tablet (from ainovo, a Chinese company). (http://engt.co/vyK8Zn for more info).

The tablet comes running Android 4.0.1. Now, I'm not about to replace my iPad 2 with it, but considering that this tablet costs $110 + $30 shipping, it's a pretty good deal right now. I'm building an app for schools, who are desperately poor right now, so an iPad is just too expensive...but the Novo 7 would be ideal.

Anyway, I got the android SDK installed on my Mac, and was finally able to create the APK as a standalone app.

When I tried to install it from the command line (adb install name.apk), I was told INSTALL_FAILED_CONTAINER_ERROR. Odd, but after googling a bit someone had said that if they'd set the location preference to anything other than "internal only" they got this error.

Okay, so I change the Install Location to "Internal Only", and try again. This time I get INSTALL_FAILED_INVALID_APK.

Hrm...so I try it on my Google Nexus One phone (Android 2.3.7), and it loads up on the phone just fine.

So, is this a known problem with Android 4.x? Has anyone magic to make LiveCode apps work on the Novo 7?

Thanks,

-Ken

kcorey
Posts: 62
Joined: Fri Nov 25, 2011 6:06 pm

Re: Android 4.x? (And the Novo 7)

Post by kcorey » Thu Jan 05, 2012 11:14 am

Not sure if this will help, but here is the log off the Novo 7 (adb logcat) after pushing the 'Test' button in the RunRev IDE.

D/AndroidRuntime(19227):
D/AndroidRuntime(19227): >>>>>> AndroidRuntime START com.android.internal.os.RuntimeInit <<<<<<
D/AndroidRuntime(19227): CheckJNI is OFF
D/AndroidRuntime(19227): Calling main entry com.android.commands.pm.Pm
W/ActivityManager( 128): No content provider found for permission revoke: file:///data/local/tmp/tmp.94006.QiCvQ1Xq
W/ActivityManager( 128): No content provider found for permission revoke: file:///data/local/tmp/tmp.94006.QiCvQ1Xq
E/PackageManager( 128): ---------------------------------in else if /data/app/com.flippinbits.drawscribble-1.apk---/data/data/com.flippinbits.drawscribble/lib
I/NativeLibraryHelper( 128): hello +++++++++++++++++++++++++++++++++++++++++ /data/app/com.flippinbits.drawscribble-1.apk --- /data/app/com.flippinbits.drawscribble-1.apk ---(null) ok
D/NativeLibraryHelper( 128): Comparing ABIs mips versus armeabi/librevandroid.so
D/NativeLibraryHelper( 128): abi didn't match anything: armeabi/librevandroid.so (end at 7)
I/NativeLibraryHelper( 128): hello +++++++++++++++++++++++++++++++++++++++++ /data/app/com.flippinbits.drawscribble-1.apk --- /data/app/com.flippinbits.drawscribble-1.apk ---(null) ok
D/NativeLibraryHelper( 128): Comparing ABIs armeabi versus armeabi/librevandroid.so
D/NativeLibraryHelper( 128): Using ABI armeabi
D/NativeLibraryHelper( 128): --------------------commond is /vendor/bin/ABI_filter /data/data/com.flippinbits.drawscribble/lib/librevandroid.so armeabi /data/data/com.flippinbits.drawscribble/lib/librevandroid.so **********!
D/NativeLibraryHelper( 128): system exec commond success , ret is 65280 !
D/NativeLibraryHelper( 128): --------------------execCommand error please check! returnValue is 255
E/PackageManager( 128): --------------------------------- NativeLibraryHelper.copyNativeBinariesIfNeededLI err!
W/PackageManager( 128): Package couldn't be installed in /data/app/com.flippinbits.drawscribble-1.apk
D/dalvikvm( 128): GC_EXPLICIT freed 232K, 16% free 13439K/15879K, paused 3ms+6ms
D/AndroidRuntime(19227): Shutting down VM
I/AndroidRuntime(19227): NOTE: attach of thread 'Binder Thread #3' failed
D/dalvikvm(19227): GC_CONCURRENT freed 120K, 78% free 459K/2048K, paused 0ms+1ms

andyh1234
Posts: 382
Joined: Mon Aug 13, 2007 4:44 pm
Location: Sale UK / FL USA
Contact:

Re: Android 4.x? (And the Novo 7)

Post by andyh1234 » Thu Jan 05, 2012 11:35 am

I was having a similar issue with a device running Ice Cream Sandwich, but the latest Android SDK updates seems to have fixed them so it might be worth checking there are no updates available there.

In the meantime, while the errors occurred I found the only way I could get a test on the device was to create an actual installer, upload it to my web account, then use the browser on the device to load the apk and install it that way. Not ideal and very slow, but it worked.

kcorey
Posts: 62
Joined: Fri Nov 25, 2011 6:06 pm

Re: Android 4.x? (And the Novo 7)

Post by kcorey » Thu Jan 05, 2012 3:36 pm

Thanks for the answer.

Hrm...that's funny. I /just/ downloaded the SDK last night, so I'd assume it's up to date.

...Nope, just checked to make sure, but I am up to date.

Ah well, I'll keep looking.

-Ken

jacque
VIP Livecode Opensource Backer
VIP Livecode Opensource Backer
Posts: 5155
Joined: Sat Apr 08, 2006 8:31 pm
Location: Minneapolis MN
Contact:

Re: Android 4.x? (And the Novo 7)

Post by jacque » Thu Jan 05, 2012 6:46 pm

I usually bypass all that entirely. I build the apk in LiveCode and copy it to my Dropbox folder. On my Android device, open the Dropbox app (it's free in the market), click the apk, and it installs. It's quick, easy, free, but you do need a Dropbox account. Other cloud solutions would work just as well, I imagine.
Jacqueline Landman Gay | jacque at hyperactivesw dot com
HyperActive Software | http://www.hyperactivesw.com

kcorey
Posts: 62
Joined: Fri Nov 25, 2011 6:06 pm

Re: Android 4.x? (And the Novo 7)

Post by kcorey » Sun Jan 08, 2012 5:20 pm

Hi Jacque,

Thanks for the idea! I tried dropbox, and downloaded the APK, but no joy still.

I have to think it's either an Android 4.0 issue or a Novo 7 issue for Livecode.

Ah well, thanks anyway.

-Ken

mathias.lin
Posts: 3
Joined: Mon Jan 30, 2012 5:24 pm

Re: Android 4.x? (And the Novo 7)

Post by mathias.lin » Mon Jan 30, 2012 5:31 pm

I have the same problem with the Novo 7 Paladin. Below is my log.
Ken, did you get this working yet? I also have the latest SDK installed. (I'm on Mac OS X Lion.)
I'm based in South China, and occasionally in Hong Kong. I might go to see the vendor and check with them.

For some reason I cannot post the log here directly ("Your account does not have permission to post links or domain/page references."). So please see the pastebin link:

pastebin [dot] com [slash] jhGhRsv7

Klaus
Posts: 11313
Joined: Sat Apr 08, 2006 8:41 am
Location: Germany
Contact:

Re: Android 4.x? (And the Novo 7)

Post by Klaus » Mon Jan 30, 2012 6:17 pm

hi Mathias,

yes, you need a certain amount of postings before you can post a working link here.

Here is the link: http://pastebin.com/jhGhRsv7


Best

Klaus

mathias.lin
Posts: 3
Joined: Mon Jan 30, 2012 5:24 pm

Re: Android 4.x? (And the Novo 7)

Post by mathias.lin » Tue Jan 31, 2012 2:31 am

@jacque @kcorey: the approach with downloading the apk, instead of going through adb, doesn't work for me either (just as Ken reported). I am still getting the same error message.

(@klaus: thanks for linking!)

sturgis
Livecode Opensource Backer
Livecode Opensource Backer
Posts: 1682
Joined: Sat Feb 28, 2009 11:49 pm

Re: Android 4.x? (And the Novo 7)

Post by sturgis » Tue Jan 31, 2012 3:19 am

I found this text:
The build shipped on the device is an engineering version, which means many (as in many) apps won't appear in the Market, and as I found out when trying the Amazon Appstore, side loading is broken -- try to load an apk file of any sort, and you're told the apk installer has crashed
on this site: http://www.androidcentral.com/novo-7-mi ... wich-hands Haven't found a page that detail how to get side loading to work but there might be useful info on the androidcentral.com site.

Also found the following in the comments:
The real issue with this tablet is not the ROM but the MIPS processor. The Honeycomb version works just fine, but a lot of apps (from what I've read, those that don't rely solely on Java) simply won't work because MIPS uses a different instruction set than the ARM used by the processors of other Android devices, and it's my understanding that no amount of tinkering with the ROM will fix that--developers will have to code for MIPS. Ainol also makes a Novo7 Advanced, though (the one here is the Basic), with similar hardware other than an ARM Cortex A10 CPU, and though it's a bit pricier and doesn't have ICS yet, it's been so popular that it's sold out most places.
Does this affect rev apps?

mathias.lin
Posts: 3
Joined: Mon Jan 30, 2012 5:24 pm

Re: Android 4.x? (And the Novo 7)

Post by mathias.lin » Tue Jan 31, 2012 3:34 am

Sturgis, thanks for the interesting link. Yes, I also noticed that many apps don't show up in the market, i.e. Astro Manager (while it's add-on app shows up though), Adobe pdf viewer, etc.

About the apps not running: but even apps that are entirely java-based don't seem to be working; at least I don't think there's anything non-java in the Google IO Schedule app. I read on StackOverflow that the mentioned error (invalid apk) is often the case when using flash (or built with Flash Builder), but this doesn't seem to be the case here. I will look further into it and try to break the app down to see what exactly causes the problem.

sturgis
Livecode Opensource Backer
Livecode Opensource Backer
Posts: 1682
Joined: Sat Feb 28, 2009 11:49 pm

Re: Android 4.x? (And the Novo 7)

Post by sturgis » Tue Jan 31, 2012 3:39 am

If you get things figured out let me know. It looks like it might be a pretty decent little tablet for the price-- if you can get it to sit up and do trucks.

kcorey
Posts: 62
Joined: Fri Nov 25, 2011 6:06 pm

Re: Android 4.x? (And the Novo 7)

Post by kcorey » Fri Feb 03, 2012 11:32 am

I haven't gotten any further with it as I'm still wrapping my head around LiveCode (which is taking a surprisingly long time).

Anyway, if I find anything out I'll let you know...please do the same.

-Ken

mwieder
VIP Livecode Opensource Backer
VIP Livecode Opensource Backer
Posts: 2847
Joined: Mon Jan 22, 2007 7:36 am
Location: Berkeley, CA, US
Contact:

Re: Android 4.x? (And the Novo 7)

Post by mwieder » Fri Feb 03, 2012 6:14 pm

At first glance, my guess is that the MIPS processor thing will kill this. I wouldn't expect binaries to be portable from ARM devices. Just a guess, though, since I don't have my hands on a Novo 7.

markw
VIP Livecode Opensource Backer
VIP Livecode Opensource Backer
Posts: 32
Joined: Mon Mar 04, 2013 4:44 pm

Re: Android 4.x? (And the Novo 7)

Post by markw » Tue Mar 05, 2013 3:34 pm

Just bumping and confirming the answer to a year-old thread - found through a StackOverflow link.

MIPS was the problem with the Novo 7. At the time this was posted the Android NDK did not have support for MIPS out of the box (I believe it was added in November last year). I suspect the Android 4 support library dependency in the Google I/O app had a native dependency.

LiveCode has a C++ engine and mostly runs as native code on Android as I understand it.

This raises the question - does LiveCode have support for MIPS or x86 deployment on Android now? If not it could make for a reasonably easy thing to contribute.

It's probably relevant given the education angle as there are some extremely cheap MIPS devices coming out of China and if, as a mobile development student, you wanted to play with an Android simulator because you didn't have a device then the x86 simulator is massively faster than the ARM-based one.

Post Reply

Return to “Android Deployment”